
package de.codedo.conflicteditor;

import org.codehaus.jackson.JsonNode;

public class Conflict extends Object
{
    private JsonNode _currentVersionNode;

    public Conflict(JsonNode node)
    {
        super();
        _currentVersionNode = node.findValue("key");
    }

    public JsonNode getCurrentDocument()
    {
        return _currentVersionNode;
    }

    public String getId()
    {
        return _currentVersionNode.findValue("_id").getTextValue();
    }

    /**
     * @return the currently active revision of the document
     */
    public String getRevision()
    {
        return _currentVersionNode.findValue("_rev").getTextValue();
    }

    /**
     * @return the conflicting revision
     */
    public String getConflictRevision()
    {
        JsonNode conflictsNode = _currentVersionNode.findValue("_conflicts");
        if (conflictsNode.isArray())
        {
            return conflictsNode.get(0).getTextValue();
        }

        throw new IllegalStateException("this node does not have conflicts");
    }
}
