
package de.codedo.conflicteditor;

import static org.hamcrest.core.IsEqual.equalTo;
import static org.junit.Assert.assertThat;

import java.net.MalformedURLException;
import java.net.URL;

import org.junit.Test;

public class CouchDbTestCase extends Object
{
    @Test(expected = IllegalArgumentException.class)
    public void nullUrl() throws Exception
    {
        new CouchDb(null);
    }

    @Test(expected = MalformedURLException.class)
    public void emptyUrl() throws Exception
    {
        new CouchDb("");
    }

    @Test
    public void extendBaseUrlEndingWithSlash() throws Exception
    {
        String baseUrl = "http://localhost:5984/test/";
        CouchDb db = new CouchDb(baseUrl);
        URL extended = db.urlByAddingPath("/foo");
        assertThat(extended.toString(), equalTo("http://localhost:5984/test/foo"));
    }

    @Test
    public void urlForDocumentAndRevision() throws Exception
    {
        String baseUrl = "http://localhost:5984/test/";
        CouchDb db = new CouchDb(baseUrl);
        URL docUrl = db.urlForDocumentAndRevision("doc", "revision");
        assertThat(docUrl.toString(), equalTo("http://localhost:5984/test/doc?rev=revision"));
    }
}
